#pragma once

#include "custom_partition.hpp"
#include "partition_point.hpp"

#include <boost/iterator/filter_iterator.hpp>

namespace boost {

/* Template functions lower_bound, upper_bound, equal_range and binary_search
expressed in terms of partition_point, special version for filter_iterator */
BOOST_CUSTOM_PARTITION( ((class)(FilterPred))((class)(It)), filter_iterator<FilterPred BOOST_PP_COMMA() It>, itBegin, itEnd, UnaryPred, pred ) {
  _ASSERT(itBegin.end()==itEnd.end());
  return make_filter_iterator(
    itBegin.predicate(),
    partition_point(
      itBegin.base(),
      itEnd.base(),
      pred
    ),
    itBegin.end()
  );
}

}; /* namespace */

#include "iterator_range.h"

template< class Range, class Pred >
iterator_range< boost::filter_iterator< Pred, typename boost::range_iterator<Range>::type > > make_filter_range( Range& rng, Pred p ) {
	return make_filter_range( boost::begin(rng), boost::end(rng), p );
}

template<class Pred, class It>
iterator_range< boost::filter_iterator< Pred, It > > make_filter_range( It itBegin, It itEnd, Pred pred ) {
	return ::make_iterator_range( boost::make_filter_iterator(pred, itBegin, itEnd), boost::make_filter_iterator(pred, itEnd, itEnd) );
}
