#pragma once

#include "custom_partition.hpp"
#include "partition_point.hpp"
#include <boost/iterator/transform_iterator.hpp>

namespace boost {

/* Template functions lower_bound, upper_bound, equal_range and binary_search
expressed in terms of partition_point, special version for transform_iterator */
BOOST_CUSTOM_PARTITION( ((class)(UnaryFunction))((class)(It)), transform_iterator<UnaryFunction BOOST_PP_COMMA() It>, itBegin, itEnd, UnaryPred, pred ) {
  return make_transform_iterator(
    partition_point(
      itBegin.base(),
      itEnd.base(),
	  bind( pred, boost::bind( itBegin.functor(), _1 ) )
    ),
    itBegin.functor()
  );
}

}; /* namespace */


/////////////////////////////////
//
// make_transform_range
//
#include "iterator_range.h"

template< class Range, class UnaryFunction >
iterator_range< boost::transform_iterator< UnaryFunction, typename boost::range_iterator<Range>::type > > make_transform_range( Range& rng, UnaryFunction f ) {
	return make_transform_range( boost::begin(rng), boost::end(rng), f);
}

template<class It, class UnaryFunction>
iterator_range< boost::transform_iterator< UnaryFunction, It > > make_transform_range( It itBegin, It itEnd, UnaryFunction fn ) {
	return ::make_iterator_range( boost::make_transform_iterator(itBegin, fn), boost::make_transform_iterator(itEnd, fn) );
}
